﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing.Design;
using System.Windows.Forms.Design;
using System.Windows.Forms;
using System.ComponentModel.Design;

namespace X.FCKeditor
{
    internal sealed class CustomConfigurationEditor : UITypeEditor
    {
        public override UITypeEditorEditStyle GetEditStyle(System.ComponentModel.ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.Modal;
        }
        public override object EditValue(System.ComponentModel.ITypeDescriptorContext context, IServiceProvider provider, object value)
        {
            string temp = string.Empty;
            if (value == null)
            {
                value = temp;
            }

            if (value.GetType() != typeof(string))
                return value;

            IWindowsFormsEditorService edSvc = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));

            if (edSvc != null)
            {
                FormCustomConfigurationEditor editor = new FormCustomConfigurationEditor(value as string);
                if (DialogResult.OK == editor.ShowDialog())
                {
                    temp = editor.CustomConfiguration;
                }
                else
                {
                    temp = value as string;
                }
            }
            return temp;
        }
    }
}
