using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections;
using System.IO;
using System.Text;

namespace X.FCKeditor.FileManager
{
    internal sealed class Config
    {
        const string Key_UserFilePath = "UserFilePath=";
        const string Key_UserFileMaxSize = "UserFileMaxSize=";
        const string Key_UserFileDeniedExtensions = "UserFileDeniedExtensions=";
        const string Key_UserFileCanCreateFolder = "UserFileCanCreateFolder=";

        public Config()
        {
        }

        public Config(string path, int size, string exts, bool canCreate)
        {
            userFilePath = path;
            userFileMaxSize = size;
            userFileDeniedExtensions = exts;
            userFileCanCreateFolder = canCreate;
        }

        public Config(string encodeConfig)
        {
            string[] config = Encoding.Default.GetString(Convert.FromBase64String(HttpUtility.UrlDecode(encodeConfig))).Split(":".ToCharArray());
            for (int i = 0; i < config.Length; i++)
            {
                string temp = config[i];
                if (temp.StartsWith(Key_UserFilePath))
                {
                    userFilePath = temp.Substring(Key_UserFilePath.Length);
                }
                if (temp.StartsWith(Key_UserFileMaxSize))
                {
                    userFileMaxSize = Convert.ToInt32(temp.Substring(Key_UserFileMaxSize.Length));
                }
                if (temp.StartsWith(Key_UserFileDeniedExtensions))
                {
                    userFileDeniedExtensions = temp.Substring(Key_UserFileDeniedExtensions.Length);
                }
                if (temp.StartsWith(Key_UserFileCanCreateFolder))
                {
                    userFileCanCreateFolder = Convert.ToBoolean(temp.Substring(Key_UserFileCanCreateFolder.Length));
                }
            }            
        }

        public string GetEncodeConfig()
        {
            StringBuilder temp = new StringBuilder();
            temp.AppendFormat("{0}{1}:", Key_UserFilePath, userFilePath);
            temp.AppendFormat("{0}{1}:", Key_UserFileMaxSize, userFileMaxSize);
            temp.AppendFormat("{0}{1}:", Key_UserFileDeniedExtensions, userFileDeniedExtensions);
            temp.AppendFormat("{0}{1}", Key_UserFileCanCreateFolder, userFileCanCreateFolder);
            return HttpUtility.UrlEncode(Convert.ToBase64String(Encoding.Default.GetBytes(temp.ToString())));
        }

        string userFilePath = Constants.DEFAULT_UserFilePath;

        public string UserFilePath
        {
            get { return userFilePath; }
            set { userFilePath = value; }
        }
        int userFileMaxSize = Constants.DEFAULT_UserFileMaxSize;

        public int UserFileMaxSize
        {
            get { return userFileMaxSize; }
            set { userFileMaxSize = value; }
        }
        string userFileDeniedExtensions = Constants.DEFAULT_UserFileDeniedExtensions;

        public string UserFileDeniedExtensions
        {
            get { return userFileDeniedExtensions; }
            set { userFileDeniedExtensions = value; }
        }
        bool userFileCanCreateFolder = false;

        public bool UserFileCanCreateFolder
        {
            get { return userFileCanCreateFolder; }
            set { userFileCanCreateFolder = value; }
        }
    }
}
