﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;

namespace X.FCKeditor.FileManager
{
    public partial class CurrentFolder : System.Web.UI.Page
    {
        const string scriptHelper_Message = "<script type='text/javascript' language='javascript'>OnCreateFolderCompleted({0},'{1}');</script>";
        string resourceType;
        Config configManager;

        protected void Page_Load(object sender, EventArgs e)
        {
            resourceType = Request["Type"];
            configManager = new Config(Request["Config"]);

            if (!Page.IsPostBack)
            {
                PanelFolderCreator.Visible = configManager.UserFileCanCreateFolder;
                LabelCurrentFolder.Text += resourceType + "/";
                HiddenFieldCurrentFolder.Value = LabelCurrentFolder.Text;
            }
        }
        public string GetImage(string name)
        {
            return ClientScript.GetWebResourceUrl(typeof(FCKeditor), "X.FCKeditor.FileManager.images." + name);
        }

        protected void ButtonCreateFolder_Click(object sender, EventArgs e)
        {
            try
            {
                string folderVirtualPath = configManager.UserFilePath.TrimEnd("/".ToCharArray()) + HiddenFieldCurrentFolder.Value + TextBoxCreateFolder.Text.Trim();
                LabelCurrentFolder.Text = HiddenFieldCurrentFolder.Value;
                
                string folderPhysicalPath = Server.MapPath(folderVirtualPath);
                if (Directory.Exists(folderPhysicalPath))
                {
                    LabelScriptContainer.Text = string.Format(scriptHelper_Message,"false", "目录已经存在。");
                }
                else
                {
                    Directory.CreateDirectory(folderPhysicalPath);
                    TextBoxCreateFolder.Text = string.Empty;
                    LabelScriptContainer.Text = string.Format(scriptHelper_Message,"true", "创建目录成功。");;
                }
            }
            catch(Exception ex)
            {
                LabelScriptContainer.Text = string.Format(scriptHelper_Message, "false", ex.Message);
            }
        }
    }
}
