﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;

namespace X.FCKeditor.FileManager
{
    public partial class FolderExplorer : System.Web.UI.Page
    {
        string resourceType;
        Config configManager;
        protected void Page_Load(object sender, EventArgs e)
        {
            resourceType = Request["Type"];
            configManager = new Config(Request["Config"]);
            TreeViewUserFiles.NodeStyle.ImageUrl = GetImage("Folder.gif");
            //TreeViewUserFiles.ExpandImageUrl = GetImage("FolderOpened.gif");
            //TreeViewUserFiles.CollapseImageUrl = GetImage("Folder.gif");

            if (!Page.IsPostBack)
            {
                initRootNode();
            }
        }

        void initRootNode()
        {
            TreeNode temp = new TreeNode("/", configManager.UserFilePath);
            temp.SelectAction = TreeNodeSelectAction.Select;
            temp.NavigateUrl = string.Format("javascript:showFolder('{0}','{1}');", temp.Value, temp.Value.Substring(configManager.UserFilePath.Length - 1));
            temp.ToolTip = temp.ValuePath;
            temp.Expanded = true;
            temp.PopulateOnDemand = true;
            TreeViewUserFiles.Nodes.Add(temp);
        }

        void loadNodes(TreeNode node)
        {
            string[] dirs = getSubDirectoryNames(node.Value);
            for (int i = 0; i < dirs.Length; i++)
            {
                TreeNode temp = new TreeNode(dirs[i], node.Value + dirs[i] + "/");
                temp.NavigateUrl = string.Format("javascript:showFolder('{0}','{1}');", temp.Value, temp.Value.Substring(configManager.UserFilePath.Length - 1));
                temp.Expanded = true;
                temp.PopulateOnDemand = true;
                node.ChildNodes.Add(temp);
            }
        }

        string[] getSubDirectoryNames(string path)
        {
            string[] dirs = Directory.GetDirectories(Server.MapPath(path));
            for (int i = 0; i < dirs.Length; i++)
            {
                dirs[i] = dirs[i].Substring(dirs[i].LastIndexOf("\\") + 1);
            }
            return dirs;
        }

        public string GetImage(string name)
        {
            return ClientScript.GetWebResourceUrl(typeof(FCKeditor), "X.FCKeditor.FileManager.images." + name);
        }

        protected void TreeViewUserFiles_TreeNodePopulate(object sender, TreeNodeEventArgs e)
        {
            loadNodes(e.Node);
        }
    }
}
