﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;
using System.Text.RegularExpressions;

namespace X.FCKeditor.FileManager
{
    internal sealed class FolderFileInfo
    {
        string icon = string.Empty;

        public string Icon
        {
            get { return icon; }
            set { icon = value; }
        }
        string name = string.Empty;

        public string Name
        {
            get { return name; }
            set { name = value; }
        }
        string size = string.Empty;

        public string Size
        {
            get { return size; }
            set { size = value; }
        }
        string category = string.Empty;

        public string Category
        {
            get { return category; }
            set { category = value; }
        }
        string modifyTime = string.Empty;

        public string ModifyTime
        {
            get { return modifyTime; }
            set { modifyTime = value; }
        }

        const string mediaExt = ".(mp3|avi|rm|wma|wmv)$";
        const string imageExt = ".(jpg|jpeg|png|gif|bmp|psd)$";
        const string flashExt = ".(swf|fla)$";

        public FolderFileInfo()
        {
        }
        public FolderFileInfo(string iconUrl, FileInfo fi)
        {
            icon = iconUrl;
            name = fi.Name;
            if (fi.Length < 1024)
            {
                size = string.Format("{0} Bytes", fi.Length);
            }
            else if (fi.Length < 1024 * 1024)
            {
                size = string.Format("{0} KB", fi.Length / 1024);
            }
            else
            {
                size = string.Format("{0} M", fi.Length / (1024 * 1024));
            }
            if (Regex.IsMatch(fi.Extension.ToLower(), mediaExt))
            {
                category = "Media";
            }
            else if (Regex.IsMatch(fi.Extension.ToLower(), flashExt))
            {
                category = "Flash";
            }
            else if (Regex.IsMatch(fi.Extension.ToLower(), imageExt))
            {
                category = "Image";
            }
            else
            {
                category = "File";
            }
            modifyTime = fi.LastWriteTime.ToString("yyyy-MM-dd HH:mm:ss");
        }
        public FolderFileInfo(string iconUrl, DirectoryInfo di)
        {
            icon = iconUrl;
            name = di.Name;
            size = string.Empty;
            category = "Folder";
            modifyTime = di.LastWriteTime.ToString("yyyy-MM-dd HH:mm:ss");
        }

    }
}
